--
-- Table structure for table 'document'
--

CREATE TABLE document (
  id varchar(32) NOT NULL default '',
  title varchar(200) NOT NULL default '',
  groupid varchar(4) NOT NULL default '',
  author varchar(100) NOT NULL default '',
  changeowner varchar(100) NOT NULL default '',
  changelog varchar(255) default NULL,
  releasedate datetime NOT NULL default '0000-00-00 00:00:00',
  creationdate datetime NOT NULL default '0000-00-00 00:00:00',
  body text NOT NULL,
  docid varchar(4) NOT NULL default '',
  version varchar(10) NOT NULL default '',
  lockflag char(1) NOT NULL default '',
  lockowner varchar(100) NOT NULL default '',
  PRIMARY KEY  (id,version)
) TYPE=MyISAM;

--
-- Table structure for table 'maingroup'
--

CREATE TABLE maingroup (
  id char(2) NOT NULL default '',
  name varchar(100) NOT NULL default '',
  PRIMARY KEY  (id)
) TYPE=MyISAM;

--
-- Table structure for table 'object'
--

CREATE TABLE object (
  objid int(11) NOT NULL auto_increment,
  object mediumblob NOT NULL,
  docid varchar(32) NOT NULL default '',
  mimetype varchar(100) NOT NULL default '',
  size bigint(20) NOT NULL default '0',
  filename varchar(255) NOT NULL default '',
  description varchar(255) NOT NULL default '',
  flag char(1) NOT NULL default '',
  PRIMARY KEY  (objid)
) TYPE=MyISAM;

--
-- Table structure for table 'subgroup'
--

CREATE TABLE subgroup (
  id varchar(4) NOT NULL default '',
  name varchar(100) NOT NULL default '',
  PRIMARY KEY  (id)
) TYPE=MyISAM;

